<?php
if(!defined('DOKU_LF')) define('DOKU_LF',"\n");

/* ================================================================== */
function tpl_specialpage($pagetitle, $mode, $edit, $acl, $toc_remove, $active, $pre, $post ) 
{
    global $conf, $ID, $REV, $INFO, $lang;
   	
    $svID  = $ID; 
    $svREV = $REV;
    $path  = explode(':', $svID); 
    $filelink   = ''; // link to the 'txt' file
    $found = false; // set to true if a valid file is found

	// ================= current namespace ================= 
   	$filelink   = implode(':', $path).'.'.$pagetitle;
   	$editlink = implode(':', $path).'.'.$pagetitle;
	$found = @file_exists(wikiFN($filelink));
	$current = $found;
	array_pop($path);

  	// ================= parrent namespaces ================= 
    while(!$found && count($path) > 0 && $mode >= 2){
    	$filelink   = implode(':', $path).'.'.$pagetitle;
		$found = @file_exists(wikiFN($filelink));
		array_pop($path);
		}
	
    // ================= root namespace ================= 
    if(!$found && @file_exists(wikiFN($pagetitle)) && $mode >= 3)
    { $filelink = $pagetitle; $found=1;}

    // ================= generate output ================= 
	// check if content was found and if user has enough rights
	if ($found && ($acl && (auth_quickaclcheck($filelink) >= AUTH_READ)) OR !$acl){
		// variabelize the content
		$data = p_wiki_xhtml($filelink,'',false);
		}

    // ================= DISABLE (REMOVE) TOC ================= 
	// check if TOC should be removed
	if ($data && $toc_remove){
		// remove the table of contents
		$data = preg_replace('/<div class="toc">.*?(<\/div>\n<\/div>)/s', '', $data);

		// dokuwiki automaticly creates links to headings, remove these 
		$data = preg_replace('/<h1><a name=".*?(" id=".*?(">))/s', '<h1>', $data);
		$data = preg_replace('/<h2><a name=".*?(" id=".*?(">))/s', '<h2>', $data);
		$data = preg_replace('/<h3><a name=".*?(" id=".*?(">))/s', '<h3>', $data);
		$data = preg_replace('/<h4><a name=".*?(" id=".*?(">))/s', '<h4>', $data);
		$data = preg_replace('/<h5><a name=".*?(" id=".*?(">))/s', '<h5>', $data);

		// remove closing links (</a>)
		$data = preg_replace('/<\/a><\/h1>/s', '</h1>', $data);
		$data = preg_replace('/<\/a><\/h2>/s', '</h2>', $data);
		$data = preg_replace('/<\/a><\/h3>/s', '</h3>', $data);
		$data = preg_replace('/<\/a><\/h4>/s', '</h4>', $data);
		$data = preg_replace('/<\/a><\/h5>/s', '</h5>', $data);
	}


    // ================= check if edit button [edit existing] ================= 
	// check if content was found, edit button is requested and if user has enough rights
	if ($found && $edit && auth_quickaclcheck($filelink) >= AUTH_EDIT){
		// create and add the button
		$data .= html_btn('edit',$filelink,'',array('do'=>'edit','rev'=>'','post'));
		}

    // ================= check if edit button [create in current namespace] ================= 
	// check if create button is set ok 'on' and if user has enough rights
	if ($edit && !$current && auth_quickaclcheck($filelink) >= AUTH_CREATE){
		// create and add the button
		$data .= html_btn('create',$editlink,'',array('do'=>'edit','rev'=>'','post'));
		}

    // ================= REPLACE CSS CLASS WITH ACTIVE CLASS FOR CURRENT PAGE ================= 
	if ($active == 1) {//current mode; highlight the link to the current page only
		$data = preg_replace('/class="wikilink1" title="'.$svID.'"/s', 'class="wikilink_active" title="'.$svID.'"', $data);
		}
	elseif ($active == 2){ // recursive mode; highlight the root namespace page link of the current page
		$ID_MAIN = explode(':', $svID); // get the name of the root namespce
		$data = preg_replace('/class="wikilink1" title="'.$ID_MAIN[0].'"/s', 'class="wikilink_active" title="'.$svID.'"', $data);
		}

    // ================= output if not empty incl. pre and post ================= 
	// chek if there was output generated at all
	if ($data) {$data = $pre.$data.$post;}

    // ================= clean up ================= 
    $ID  = $svID; $REV = $svREV;

    
    print $data;
}?>